<?php
/*****************************************************************************
 *   Second hand items module (/inc/plugins/myplaza/sale.php)
 *   By Keyvan fakhri shojaie
 *   Last modified: 2008/02/19 by Keyvan
 *   add second hand items page to myplaza
 *****************************************************************************/

if(!defined("IN_MYBB"))die("This file cannot be accessed directly.");

function sale_info(){
	return array(
		"name"			=> "Second Hand Items",
		"description"	=> "Allows users to sell his/her item to other users (need inventory module)",
		"website"		=> "http://www.keyvan.ws/projects/mybb/myplaza_modules",
		"author"		=> "Keyvan fakhri shojaie",
		"authorsite"	=> "http://www.keyvan.ws",
		"version"		=> "1.1",
	);
}

function sale_lang(){
	global $mybb,$lang;
	switch($mybb->settings['bblanguage']){
		default:
			$lang->sale='Second Hand Items';
			$lang->buy='Buy';
			$lang->buy_accept ='Are you sure you want to buy this item?';
			$lang->sale_cancel='Cancel Selling?';
			$lang->cancel_accept ='Are you sure that you want to cancel the sale of this item?';
			$lang->yes='Yes, I\'m sure';
			$lang->seller='Seller';
			$lang->item_price='Item price';
			$lang->viewing_sale='Viewing Second Hand Items';
			$lang->buy_success="Item bought successfully.";
			$lang->cancel_success="Item has been restored back to your inventory.";
			$lang->sell_success="Item is now shown on the second hand items page.";
			$lang->enough_money="Sorry, you don\'t have enough money.";
			$lang->sale_buy_log='You bought <a href=\'plaza.php?iid=%s\'>%s</a> from <a href="member.php?action=profile&uid=%s">%s</a> for %s';
			$lang->sale_sell_log='You sold <a href=\'plaza.php?iid=%s\'>%s</a> to <a href="member.php?action=profile&uid=%s">%s</a> for %s';
	}
}

function sale_lang_admin(){
	global $mybb,$lang;
	switch($mybb->settings['bblanguage']){
		default:
			$lang->inventory_notinstalled="You must first install the Inventory module";
	}
}

define('SALE_ADD_TEMPLATE_PLAZAHEADER','<li><a href="{$mybb->settings[\'bburl\']}/plaza.php?action=page&amp;p=sale"><img src="{$mybb->settings[\'bburl\']}/images/myplaza/sale.gif" alt="" />{$lang->sale}</a></li>');
	
function sale_activate(){
	global $cache,$lang;
	$module_cache=$cache->read('myplaza_modules');
	if(isset($module_cache['inventory'])){
		db_create_table('plaza_sale', array(
			'iid' => array('type' => 'int', 'size' => 10, 'not_null' => true),
			'uid' => array('type' => 'int', 'size' => 10, 'not_null' => true),
			'price' => array('type' => 'decimal', 'size' => '20,2', 'not_null' => true),
		), array());
		myplaza_langload('sale',true);

		$new_templates = array();
		$new_templates['plaza_sale'] = '
{$plaza_header}
<table border="0" cellspacing="{$theme[\'borderwidth\']}" cellpadding="{$theme[\'tablespace\']}" class="tborder">
	<tr><td class="thead" colspan="{$mybb->settings[\'inventory_page_w\']}"><img src="{$mybb->settings[\'bburl\']}/images/myplaza/sale.gif" class="plazaitem" alt="" /><strong>{$lang->viewing_sale}</strong></td></tr>
	<tr>{$itemdata}</tr>
	<tr><td class="tfoot" colspan="{$mybb->settings[\'inventory_page_w\']}">$multipage</td></tr>
</table>
{$plaza_footer}
	';
		$new_templates['plaza_sale_item'] = '<td class="{$bgcolor}" align="left" width="{$columnwidth}%" valign="top">
	<img src="{$item[\'image\']}" align="left" style="margin-right: 5px; margin-bottom: 5px;" alt="{$lang->item_image}" /><a href="{$mybb->settings[\'bburl\']}/plaza.php?iid={$item[\'iid\']}"><strong>{$item[\'formattedname\']}</strong></a>
	<br /><span class="smalltext">{$item[\'description\']}</span>
	<br />{$lang->seller}: <a href="member.php?action=profile&uid={$userinfo[\'uid\']}">{$userinfo[\'username\']}</a>
	<br />{$lang->item_price}: {$item[\'price\']}
	<br />{$item_cancel} {$item_buy}
</td>';
		$new_templates['plaza_sale_cancel'] = '[<a href="javascript:void(0)" id="cancel_{$item[\'iid\']}">{$lang->sale_cancel}</a>]
<div id="cancel_{$item[\'iid\']}_popup" class="popup_menu" style="display: none; padding: 15px; background: #FFFFFF; color: #000000; border: 1px solid #000000; width: 200px;">
	{$lang->cancel_accept}
	<form action="plaza.php?action=page&amp;p=sale" method="post">
		<input type="hidden" name="postcode" value="{$mybb->post_code}" />
		<input type="hidden" name="iid" value="{$item[\'iid\']}" />
		<input type="hidden" name="invaction" value="cancel" />
		<input type="hidden" name="process" value="yes" />
		<br /><input type="submit" value="{$lang->yes}" class="button" />
	</form>
</div>
<script type="text/javascript">
	new MyPlazaPopupMenu("cancel_{$item[\'iid\']}");
</script></a>';

		$new_templates['plaza_sale_buy'] = '
[<a href="javascript:void(0)" id="buy_{$item[\'iid\']}">{$lang->buy}</a>]
<div id="buy_{$item[\'iid\']}_popup" class="popup_menu" style="display: none; padding: 15px; background: #FFFFFF; color: #000000; border: 1px solid #000000; width: 200px;">
	{$lang->buy_accept}
	<form action="plaza.php?action=page&amp;p=sale" method="post">
		<input type="hidden" name="postcode" value="{$mybb->post_code}" />
		<input type="hidden" name="iid" value="{$item[\'iid\']}" />
		<input type="hidden" name="invaction" value="buy" />
		<input type="hidden" name="process" value="yes" />
		<br /><input type="submit" value="{$lang->yes}" class="button" />
	</form>
</div>
<script type="text/javascript">
	new MyPlazaPopupMenu("buy_{$item[\'iid\']}");
</script>';


		add_templates($new_templates);
		find_replace_myplaza_template('plaza_header','{$lang->myinventory}</a></li>', '{$lang->myinventory}</a></li>'.SALE_ADD_TEMPLATE_PLAZAHEADER, 'str_replace');
		plugins_add_passive_hook('plaza_start','sale_loadlang');
	}else{
		myplaza_cpredirect('action=modules',$lang->inventory_notinstalled,$mybb->input['referrer']);
	}
}

function sale_deactivate(){
	global $db;
	db_drop_tables('plaza_sale');
	$db->delete_query(MY_TABLE_PREFIX.'templates','title IN (\'plaza_sale\',\'plaza_sale_item\',\'plaza_sale_cancel\',\'plaza_sale_buy\') AND sid=\'-1\'');
	myplaza_remove_module_items();
	plugins_remove_passive_hooks();	
	find_replace_myplaza_template('plaza_header',SALE_ADD_TEMPLATE_PLAZAHEADER,'','str_replace');
}

function sale_run(){}

function sale_plugin(){
	global $plugins;
	$plugins->add_hook('myplaza_inventory_run_sell', 'sale_inventory_run_sell',11);
}

function sale_page(){
	global $plaza_header,$mybb,$lang,$multipage,$title,$theme,$templates,$plugins,$itemdata,$db;
	$iid=intval($mybb->input['iid']);
	if($mybb->input['invaction']=='buy' && $mybb->input['process']=='yes'){
		$item=$db->fetch_array($db->query("SELECT * FROM ".MY_TABLE_PREFIX."plaza_sale s,".MY_TABLE_PREFIX."plaza_items i WHERE s.iid=$iid AND s.iid=i.iid"));
		if($mybb->user[MYPLAZA_MONEY_COLUMN]<$item['price']){
			redirect('plaza.php?action=page&p=sale&iid='.$iid,$lang->enough_money);
		}
		$seller_info=get_user($item['uid']);
		user_change_money($mybb->user,-$item['price']);
		user_change_money($seller_info,$item['price']);
		
		$useritems=unserialize($mybb->user['inventory']);
		if($useritems[$iid]>0){
			$useritems[$iid]+=1;
		}else{
			$useritems[$iid]=1;
		}
		$useritems= serialize($useritems);
		$db->update_query(MY_TABLE_PREFIX.'users',array('inventory'=>$useritems),'uid='.$mybb->user['uid'],1);
		$db->insert_query(MY_TABLE_PREFIX.'plaza_buylog',array(
			'iid'=>$iid,
			'uid'=>$mybb->user['uid'],
			'description'=>$db->escape_string(sprintf($lang->sale_buy_log,$iid,$item['name'],$seller_info['uid'],$seller_info['username'],my_format_money($item['price']))),
			'dateline'=>time()
		));
		$db->insert_query(MY_TABLE_PREFIX.'plaza_buylog',array(
			'iid'=>$iid,
			'uid'=>$seller_info['uid'],
			'description'=>$db->escape_string(sprintf($lang->sale_sell_log,$iid,$item['name'],$mybb->user['uid'],$mybb->user['username'],my_format_money($item['price']))),
			'dateline'=>time()
		));
		$db->delete_query(MY_TABLE_PREFIX.'plaza_sale',"iid=$iid");
		redirect('plaza.php?action=page&p=inventory',$lang->buy_success);
	}elseif($mybb->input['invaction']=='cancel' && $mybb->input['process']=='yes'){
		$useritems=unserialize($mybb->user['inventory']);
		if($useritems[$iid]>0){
			$useritems[$iid]+=1;
		}else{
			$useritems[$iid]=1;
		}
		$useritems=serialize($useritems);
		$db->update_query(MY_TABLE_PREFIX.'users',array('inventory'=>$useritems),'uid='.$mybb->user['uid'],1);
		$db->delete_query(MY_TABLE_PREFIX.'plaza_sale',"iid=$iid");
		redirect('plaza.php?action=page&p=inventory',$lang->cancel_success);
	}
	
	$page = intval($mybb->input['page']);
	if($page < 1) $page = 1;
	$items_w = intval($mybb->settings['inventory_page_w']);
	if($items_w < 1) $items_w = 5;
	$perpage = intval($mybb->settings['inventory_page_w']) * intval($mybb->settings['inventory_page_h']);
	if($perpage < 1) $perpage = $items_w * 4;
	
	if($iid){
		$q=$db->query("SELECT * FROM ".MY_TABLE_PREFIX."plaza_sale s,".MY_TABLE_PREFIX."plaza_items i,".MY_TABLE_PREFIX."plaza_inventory_items ii WHERE s.iid=$iid AND i.iid=s.iid AND s.iid=ii.iid ");	
		$allitems=1;
	}else{
		$allitems=$db->fetch_field($db->query("SELECT COUNT(*) FROM ".MY_TABLE_PREFIX."plaza_sale"),'COUNT(*)');
		$q=$db->query("SELECT * FROM ".MY_TABLE_PREFIX."plaza_sale s,".MY_TABLE_PREFIX."plaza_items i,".MY_TABLE_PREFIX."plaza_inventory_items ii WHERE i.iid=s.iid AND s.iid=ii.iid LIMIT ".($page-1)*$perpage.",$perpage");
	}

	$items_count=$db->num_rows($q);
	if($items_count>0){
		$templates->cache('plaza_sale,plaza_sale_item,plaza_sale_cancel');
		$pages = ceil($items_count / $perpage);
		if($page > $pages && $pages > 1) $page = $pages;
		$columnwidths = array();
		$float_width = 100/$items_w;
		$accumulator = 0;
		for($i=1; $i<=$items_w; $i++){
			$columnwidths[$i-1] = round($float_width * $i - $accumulator, 1);
			$accumulator += $columnwidths[$i-1];
		}
		$itemcounter = 1;
		$itemdata = '';
		$prev_cid = 0;
		do{
			while($skip || $item = $db->fetch_array($q)){
					$userinfo=get_user($item['uid']);
					if((($itemcounter-1) % $items_w) == 0 && $itemcounter > 1){
						$itemdata .= '</tr><tr>';
						if(($items_w % 2) == 0)
							$bgcolor = alt_trow();
					}
					$bgcolor = alt_trow();
					$columnwidth = $columnwidths[($itemcounter-1) % $items_w];
					
					$item['formattedname'] = format_item($item['name'], $item['format']);
					if($item['image']){
						if(!preg_match('#[a-z]+?://#si', $item['image']))
							$item['image'] = $mybb->settings['bburl'].'/images/myplaza/inventory/'.$item['image'];
					}elseif($item['icon']){
						$item['image'] = $mybb->settings['bburl'].'/images/myplaza/'.$item['icon'];
					}else{
						$item['image'] = $mybb->settings['bburl'].'/images/myplaza/item.png';
					}
					if($item['uid']==$mybb->user['uid']){
						eval('$item_cancel = "'.$templates->get('plaza_sale_cancel').'";');
						$item_buy='';
					}else{
						eval('$item_buy = "'.$templates->get('plaza_sale_buy').'";');
						$item_cancel='';
					}
					$item['value'] = my_format_money(calcCost($item['cost']));
					eval('$itemdata .= "'.$templates->get('plaza_sale_item').'";');
					++$itemcounter;
			}
			while(($itemcounter-1) % $items_w){
					$bgcolor = alt_trow();
					$columnwidth = $columnwidths[($itemcounter-1) % $items_w];
					eval('$itemdata .= "'.$templates->get('plaza_sale_item_blank').'";');
					++$itemcounter;
			}
		}while($itemcounter < $perpage && $item);
		$multipage = multipage($allitems,$perpage,$page, "plaza.php?action=page&amp;p=sale");
	}
	$title = strip_tags($lang->viewing_sale);
	return $templates->get('plaza_sale');
}

function sale_inventory_run_sell($item){
	global $mybb,$db,$lang;
	$iid=intval($mybb->input['iid']);
	$item=$db->fetch_array($db->simple_select(MY_TABLE_PREFIX.'plaza_items','*','iid='.$iid));
	$sell_price=calcCost($item['cost'],floatval($mybb->settings['inventory_sell_rate']));
	$sell_price=round($sell_price, $mybb->settings['myplaza_money_decimals']);
	$row=array(array(
		'iid'=>$iid,
		'uid'=>$mybb->user['uid'],
		'price'=>$sell_price
	));
	db_insert_rows('plaza_sale',$row);	
	$useritems=unserialize($mybb->user['inventory']);
	if($useritems[$iid]>1){
		$useritems[$iid]-=1;
	}elseif($useritems[$iid]==1){
		unset($useritems[$iid]);			
	}
	$mybb->user['inventory'] = serialize($useritems);
	$db->update_query(MY_TABLE_PREFIX.'users', array('inventory' => ($mybb->user['inventory'])), 'uid='.$mybb->user['uid'], 1);
	redirect('plaza.php?action=page&p=sale&iid='.$iid,$lang->sell_success);
}

function sale_loadlang(){
	myplaza_langload('sale');
}
?>